//(function(){

var imagesDir = "images/";
var soundsDir = "audio/";
var preload;
var manifest = [];
var muteSounds = false;

var data;
var cardCols = 4;
var cardRows = 4;
//var cardSpacing = 10;
//var cardWidth;
//var cardHeight;
var cards;
var cardBackImg;
//var cardDivs = new Array();
var picks = new Array();
var pickNum;
var cardAniComplete;
var flipSpeed = 200;
var flippedPause = 700;
var fadeSpeed = 500;
var cardsFlipped;
var matches;
var chances = 40;//JSON will override
var chanceLevels = [40,30,20];//JSON will override
var score;
var contentHeight;

$(document).ready(function(){
	// hide everything but preloader
	$('#memory_cards').hide();
	$('#memory_bottom').hide();
	$('#memory_window_holder').hide();
	$('#memory_end').hide();

	getJSON();
});
	
function getJSON(){
	//console.log("loading JSON");
	$.getJSON('memory.json', function(result){
		data = result;
		//console.log("loaded JSON");
		
		chances = Number(data.memory.chances.easy);
		chanceLevels = [Number(data.memory.chances.easy), Number(data.memory.chances.medium), Number(data.memory.chances.hard)];

		preloadAssets();
	}).fail(function(jqXHR, textStatus, errorThrown) {
		//console.log("JSON " + errorThrown);
	});
}

// find images in JSON and add to preload manifest
function recurse(key, val) {
	if (val instanceof Object) {
		$.each(val, recurse);
	} else {
		if (val.match(/\.(gif|jpg|jpeg|png)/gi)){
			var duplicate = false;
			for (var i = 0; i < manifest.length; i++){
				//console.log(val + " vs" + String(manifest[i]).split("/").pop());
				if (val == String(manifest[i]).split("/").pop()){
					duplicate = true;
					break;
				}
			}
			if (!duplicate){
				//console.log("add to manifest: " + val);
				manifest.push(imagesDir + val);
			}
		}
	}
}

// preload images and sounds
function preloadAssets(){

	//add images to manifest
	$.each(data, recurse);

	// add audio to manifest
	var fileType = ".mp3";
	var obj = data.memory.sounds;
	for (var key in obj) {
		var val = obj[key];
		//console.log(key + ": " + soundsDir + val + fileType);
		manifest.push({id: key, src: soundsDir + val + fileType});
	}
	
	//console.log("manifest(" + manifest.length + "): " + manifest.toString());
	createjs.Sound.registerPlugins([createjs.WebAudioPlugin, createjs.HTMLAudioPlugin]);
	createjs.Sound.alternateExtensions = ["ogg"];//"mp3", "m4a", "wav"
	preload = new createjs.LoadQueue(true);//use false for local testing - true required for audio
	preload.installPlugin(createjs.Sound);
	preload.setMaxConnections(5);
	preload.on("fileload", handleFileLoad);
	preload.on("progress", handleOverallProgress);
	preload.on("fileprogress", handleFileProgress);
	preload.on("error", handleFileError);
	loadAll();
}

function loadAll() {
	while (manifest.length > 0) {
		loadAnother();
	}
}

function loadAnother() {
	var item = manifest.shift();
	console.log('loading ' + item);
	preload.loadFile(item);
}

function handleFileLoad(event) {
	var img = event.result;
	console.log('loaded ' + event.item.id);
}

function handleFileProgress(event) {

}

function handleOverallProgress(event) {
	var percent = preload.progress * 100;
	//console.log('percent loaded: ' + percent);
	$('#memory_preloader_bar').css('width', percent + '%');
	if (preload.progress == 1){
		//console.log("loading complete");
		$('#memory_preloader').remove();
		if (preload != null) {
			preload.close();
		}
		init();
	}
}

function handleFileError(event) {
 	console.log('error loading ' + event.item.id + ': ' + event.target.error);
}

function init(){

	$('#memory_cards').show();
	$('#memory_bottom').show();
	$('#memory_window_holder').show();
	
	// populate end of game message text
	$('#memory_result').html(data.memory.result_text);
	
	// size card grid
	sizeGrid();
	$(window).resize(function() {
		sizeGrid();
	});
	
	// set back of card image
	cardBackImg = imagesDir + data.memory.cardBackImage;

	// create cards
	var id = 1;
	//var xPos = 0;
	//var yPos = 0;
	for (var i = 0; i < cardCols; i++){
		for (var j = 0; j < cardCols; j++){
			makeCard("card"+id);//, xPos, yPos
			id++;
			//xPos += 1;
		}
		//xPos = 0;
		//yPos += 1;
	}
	
	// add button actions
	$('#memory_settings button').mousedown(function(event){
		event.preventDefault();
		level = Number($(this).val());
		var levelNames = ["Easy", "Medium", "Hard"];
		//_trackEvent("Kids", "MemoryGame", levelNames[level]);
		_gaq.push(['_trackEvent', 'Kids', 'MemoryGame', levelNames[level]]);
		$('#memory_window_holder').hide();
		$('#memory_settings').hide();
		newGame();
	});
	
	$('#memory_play_again_button').mousedown(function(event){
		event.preventDefault();
		$('#memory_end').hide();
		$('#memory_settings').show();
	});
	
	$('#memory_audio_toggle').mousedown(function(){
		toggleAudio();
	});

	// without this a ghosted clone card image follows the cursor on click and drag in all browsers but IE
	$("img").mousedown(function(){
		return false;
	});	

	updateChances(true);
}

function sizeGrid(){
	contentHeight = $('#memory').height();
	//alert(contentHeight);
	//contentHeight = 456;//460 is full size image at 100px
	/*alert($('#memory_bottom').height());*/
	var gridSize = contentHeight - $('#memory_bottom').height();//-60
	// if window is narrower than it is tall size based on width not height (phones)
	if (gridSize > $(window).width()){
		gridSize = $(window).width() - parseFloat($('#memory').css('padding')) * 2;
	}
	//gridSize = 311;
	//alert($('#memory_chances').height());
	// making divisible by 4 prevents some shifting but not at small sizes
	gridSize = Math.floor(gridSize/4)*4;
	$('#memory_cards').css({'height': gridSize, 'width': gridSize});
	console.log("gridSize", gridSize);
	
		// create cards
	var cardsWidth = $("#memory_cards").width();
	var cardsHeight = $("#memory_cards").height();
	//cardWidth = (cardsWidth - ((cardCols - 1) * cardSpacing)) / cardCols;
	//cardHeight = (cardsHeight - ((cardRows - 1) * cardSpacing)) / cardRows;
	/*cardWidth = 100;
	cardHeight = 100;*/
	//console.log("card size", cardWidth, "x", cardHeight);	
	
	$('#memory_bottom').css({'width': gridSize});
}



// create card divs (populated based on array later)
function makeCard(id){//, xPos, yPos
	/*POSITION IS NO LONGER RELEVANT*/
	//console.log("makeCard", cardWidth, id, xPos, yPos);/**/

	var cardDIV = "#memoryCard" + id;	
	//absolute way
	/*$("#memory_cards").append("<div class='memory_card' id='memoryCard" + id + "' align='center' style='position: absolute;'></div>");
	$(cardDIV).css({left: xPos * 25 + '%', top: yPos * 25 + '%'});*/
	//relative way - causes visual shifting on flip
	//making grid divisible by 4 prevents some shifting but not at small sizes
	$("#memory_cards").append("<div id='memoryCard" + id + "' class='memory_card' align='center' />");/**/
	
	//console.log(cardDIV, "width", $(cardDIV).width());
	//cardDivs.push($(cardDIV));
	
	// add card image
	$(cardDIV).append("<img src='" + cardBackImg + "' />");
	//$(cardDIV).data('pairNum', 666);//doesn't work
}

// create and shuffle cards array
function shuffleCards(){
	// create array
	cards = new Array();
	for (var i = 1; i <= cardCols * cardRows / 2; i++){
		cards.push(i + "_1");
		cards.push(i + "_2");
	}
	// shuffle array
	var j, x, i = cards.length; 
	while (i) {
	   j = parseInt(Math.random() * i);
	   x = cards[--i];
	   cards[i] = cards[j];
	   cards[j] = x;
	}
	// add data to divs - doesn't work
	/*for (var i = 1; i <= cards.length; i++){
		$('#memoryCard' + i).data('pairNum', 666);
		console.log(i, $('#memoryCard' + i),  cards[i-1].split("_").shift());
		console.log(i, $('#memoryCard' + i).data('pairNum') );
	}*/
	//$( "#memoryCard1" ).data( 'foo', 52 );
	//$("#memoryCard1").data("pairNum", "0")
	//console.log( $("#memoryCard1"), $("#memoryCard1").data("foo") );
	
	console.log("shuffleCards", cards.toString());
}

function newGame(){

	chances = chanceLevels[level];
	/*chances = 1;*/
	updateChances(true);
	shuffleCards();	

	score = 0;
	updateScore();
	matches = 0;
	
	$('#memory_cards').show();
	$('.memory_card').css('opacity', '1').show();
	$('.memory_card img').attr('src', cardBackImg);

	startTurn();
}

function startTurn(){
	pickNum = 0;
	cardsFlipped = 0;
	enableCards();
}

function selectCard(card){
	playSound("flip");
	
	// get card number from cards array based on number in div id
	var cardNum = cards[/.*?(\d+)/.exec(card.id)[1] - 1];
	var cardImage = cardNum.split("_").pop();
	var pairNum = cardNum.split("_").shift();
	var cardImgSrc = imagesDir + data.memory.cards[pairNum-1]["image"+cardImage];
	console.log("selectCard cardNum:" + cardNum + " pairNum:" + pairNum + "cardImage: " + cardImage);
	
	// record pick
	picks[pickNum] = card;
	pickNum++;
	
	// if first pick only disable first card to allow for rapid selection
	if (pickNum == 1){
		$(card).css('cursor', 'default');
		$(card).unbind();
	// otherwise disable all cards
	} else {
		disableCards();
	}
	
	// assign card pair data - not sure why but can't add data anywhere else using $('#memoryCard' + i).data('pairNum', 666);
	$(card).data('pairNum', pairNum);
	
	// flip card
	$(card).children('img').animate({width:'0%'}, flipSpeed, 'linear',
		function() {
			this.src = cardImgSrc;
			$(this).animate({width:'100%'}, flipSpeed, 'linear',
			function() {
				cardsFlipped++;
				// check for match once 2 cards are flipped
				if (cardsFlipped == 2){
					updateChances();
					checkMatch();
				}
			});
		}
	);
}

function enableCards(){
	// cycle through card divs
	$("#memory_cards > div").each(function () {
		// if back of card is showing
		if ($(this).children('img').attr('src') == cardBackImg){
			// enable card
			$(this).css('cursor', 'pointer');
			$(this).click(function(){
				selectCard(this);
			});
		}
	});
}

function disableCards(){
	// disable all cards
	$("#memory_cards").find('div').css('cursor', 'default');
	$("#memory_cards").find('div').unbind();
}

function updateChances(init){
	if (!init){
		chances--;
	}
	$('#memory_chances div').html(chances);
}

function updateScore(num){
	if (num){
		score += Number(num);
	}
	$('#memory_score div').html(score);
}

// check to see if cards match based on pairNum data value
function checkMatch(){
	console.log($(picks[0]).data('pairNum') + " vs " + $(picks[1]).data('pairNum'));
	cardAniComplete = 0;
	// if correct
	if ($(picks[0]).data('pairNum') == $(picks[1]).data('pairNum')){
		fadeAway($(picks[0]));
		fadeAway($(picks[1]));
		updateScore(100);
		matches++;
		playSound("match");
	// if incorrect
	} else {
		flipBack($(picks[0]));
		flipBack($(picks[1]));
		playSound("nomatch");
	}
}

// return flipped cards to face down state
function flipBack(card){
	$(card).children('img').delay(flippedPause).animate({width:'0%', height:'100%'}, flipSpeed, 'linear',
		function() {
			this.src = cardBackImg;
			cardAniComplete++;
			if (cardAniComplete == 2){
				$(this).animate({width:'100%', height:'100%'}, flipSpeed, 'linear',
				function() {
					if (!chances){
						gameOver("lost");
					} else {
						startTurn();
					}
				});
			} else {
				$(this).animate({width:'100%', height:'100%'}, flipSpeed, 'linear');
			}
		}
	);
}

// fade out matching cards
function fadeAway(card){
	$(card).delay(flippedPause).fadeTo(fadeSpeed, 0,
		function() {
			cardAniComplete++;
			if (cardAniComplete == 2){
				if (!chances){
					gameOver("lost");
				} else {
					if (matches == 8){
						gameOver("won");
					} else {
						startTurn();
					}
				}
			}
		}
	);
}

function gameOver(str){
	if (str == "lost"){
		$('#memory_result').html('You ran out of moves!');
		playSound("lose");
	} else {
		$('#memory_result').html('Great job!<br />You matched all the cards!');
		playSound("win");
	}
	console.log("gameOver " + str);
	$('#memory_window_holder').show();
	$('#memory_end').show();
}

function playSound(name, loop) {
	if (!muteSounds){
		console.log("playSound " + name);
		var instance = createjs.Sound.play(name, createjs.Sound.INTERRUPT_ANY);
		instance.addEventListener("failed", function(event){console.log("failed", event.target);});
		instance.addEventListener("complete", function(event){console.log("complete", event.target);});
	}
}

function toggleAudio(){
	if (muteSounds){
		muteSounds = false;
		createjs.Sound.setMute(false);
		$('#memory_audio_toggle div').removeClass('fa-volume-off').addClass('fa-volume-up');
	} else {
		muteSounds = true;
		createjs.Sound.setMute(true);
		$('#memory_audio_toggle div').removeClass('fa-volume-up').addClass('fa-volume-off');
	}
	console.log("muteSounds: " + muteSounds);
}

//}());